.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm	; get them from http://www.masm32.com/board/index.php?topic=770.0
LOOP_COUNT	= 1000000

Smooth MACRO		; put before the algo_s label
	align 16
	REPEAT 16		; aligns and inserts some int3 to reassure the
		INT 3		; CPU that there is nothing to cache above the algo
	ENDM
ENDM

testme MACRO algo, comment
LOCAL ct
  invoke Sleep, 100
  counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
  	ct = 0
  	REPEAT 10
	  	ct = ct + 1
  		@CatStr(<push offset decstr>, %ct)
		call algo
	ENDM
  counter_end
  ifb <comment>
	print str$(eax), 9, "cycles for 10*&algo&", 13, 10
  else
	print str$(eax), 9, "cycles for 10*&comment&", 13, 10
  endif
ENDM

testcorrect MACRO algo
	push offset decstring
	call algo
	.if eax!=12345678
		print hex$(eax), 9, "ERROR in &algo&", 13, 10
	.endif
ENDM

codesize MACRO algo
  mov eax, &algo&_endp
  sub eax, &algo&_s
  print str$(eax), 9, " bytes for &algo&", 13, 10
ENDM

.data						; ############### TESTSTRINGS ###############
MyOffset = 9999
decstring	db "12345678", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr1	db "abcedfab", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr2	db "12345678", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr3	db "abcedfab", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr4	db "12345678", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr5	db "abcedfab", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr6	db "12345678", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr7	db "abcedfab", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr8	db "12345678", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr9	db "abcedfab", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr10	db "12345678", 0

.code						; ############### Get timings and code size ###############
start:
	push 1
	call ShowCpu						; print brand string and SSE level
	testcorrect atodL					; test if algos deliver correct results
	testcorrect atou
	testcorrect atou_rock
	testcorrect atodJJ

	REPEAT 2						; the timings
		testme atodL, <Lingo!'s replacement>	; if no second arg is present, the algo's original name will be shown
		testme atou
		testme atou_rock
		testme atodJJ
		print chr$(13, 10)
	ENDM

	print "Code size:", 13, 10			; code sizes
	codesize atodL
	codesize atou
	codesize atou_rock
	codesize atodJJ

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

; ###################### THE ALGOS #######################
Smooth
align 16
db 7 dup(0)
atodL_s:
atodL proc ; String:DWORD
	mov ecx, [esp+4]
	movzx eax, byte ptr [ecx]
	add ecx, 3
	movzx edx, byte ptr [ecx-2]
	mov [esp+1*4],ebx
	test eax, edx
	je @quit1
	movzx ebx, byte ptr [ecx-1]
	lea eax, [eax*4+eax]
	lea eax, [eax*2+edx-210h]
	sub ebx, 30h
	js @quit
@@:
	movzx edx, byte ptr [ecx]
	lea eax, [eax*4+eax]
	sub edx, 30h
	lea eax, [eax*2+ebx]
	js @quit
	lea eax, [eax*4+eax]
	add ecx, 2
	movzx ebx, byte ptr [ecx-1]
	lea eax, [eax*2+edx]
	sub ebx, 30h
	jns @b
@quit:
	pop ecx
	pop ebx
	jmp ecx
align 16
@quit1:
	sub eax, 30h
	jns @quit
	xor eax, eax
	pop ecx
	pop ebx
	jmp ecx
atodL endp
atodL_endp:

Smooth
atodJJ_s:
atodJJ proc ; String:DWORD
	mov edx, [esp+4]
	xor eax, eax
@@:	movzx ecx, byte ptr [edx]
	inc edx
	lea eax, [eax+eax*4]
	cmp byte ptr [edx], ch
	lea eax, [ecx+eax*2-30h]
	jnz @b
	ret 4
atodJJ   endp
atodJJ_endp:

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

Smooth
atou_rock_s:
atou_rock proc String:DWORD

    mov ecx, [esp + 4]
    push ebx

    ; ---

    movzx eax, byte ptr [ecx + 0]
    test eax, eax
    jz @@done

    sub eax, 48

    movzx edx, byte ptr [ecx + 1]
    test edx, edx
    jz @@done

    movzx ebx, byte ptr [ecx + 2]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + edx - 48]
    test ebx, ebx
    jz @@done

    movzx edx, byte ptr [ecx + 3]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + ebx - 48]
    test edx, edx
    jz @@done

    movzx ebx, byte ptr [ecx + 4]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + edx - 48]
    test ebx, ebx
    jz @@done

    movzx edx, byte ptr [ecx + 5]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + ebx - 48]
    test edx, edx
    jz @@done

    movzx ebx, byte ptr [ecx + 6]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + edx - 48]
    test ebx, ebx
    jz @@done

    movzx edx, byte ptr [ecx + 7]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + ebx - 48]
    test edx, edx
    jz @@done

    movzx ebx, byte ptr [ecx + 8]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + edx - 48]
    test ebx, ebx
    jz @@done

    movzx edx, byte ptr [ecx + 9]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + ebx - 48]
    test edx, edx
    jz @@done

    lea eax, [4*eax + eax]
    lea eax, [2*eax + edx - 48]

@@done:
    pop ebx
    ret 4

atou_rock endp
atou_rock_endp:

Smooth
atou_s:     ; start label
atou proc String:DWORD
mov ecx, [esp + 4]
    push ebx

    ; ---

    movzx eax, byte ptr [ecx + 0]
    test eax, eax
    jz @@done

    sub eax, 48

    movzx edx, byte ptr [ecx + 1]
    test edx, edx
    jz @@done

    movzx ebx, byte ptr [ecx + 2]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + edx - 48]
    test ebx, ebx
    jz @@done

    movzx edx, byte ptr [ecx + 3]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + ebx - 48]
    test edx, edx
    jz @@done

    movzx ebx, byte ptr [ecx + 4]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + edx - 48]
    test ebx, ebx
    jz @@done

    movzx edx, byte ptr [ecx + 5]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + ebx - 48]
    test edx, edx
    jz @@done

    movzx ebx, byte ptr [ecx + 6]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + edx - 48]
    test ebx, ebx
    jz @@done

    movzx edx, byte ptr [ecx + 7]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + ebx - 48]
    test edx, edx
    jz @@done

    movzx ebx, byte ptr [ecx + 8]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + edx - 48]
    test ebx, ebx
    jz @@done

    movzx edx, byte ptr [ecx + 9]
    lea eax, [4*eax + eax]			
    lea eax, [2*eax + ebx - 48]
    test edx, edx
    jz @@done

    lea eax, [4*eax + eax]
    lea eax, [2*eax + edx - 48]

@@done:
    pop ebx
    ret 4

if 0	; not part of the algo
  ; ------------------------------------------------
  ; Convert decimal string into UNSIGNED DWORD value
  ; ------------------------------------------------

    mov edx, [esp+4]
    xor ecx, ecx
    movzx eax, BYTE PTR [edx]
    test eax, eax
    jz quit

  lpst:
    add edx, 1
    lea ecx, [ecx+ecx*4]            ; mul ecx * 5
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx]
    test eax, eax
    jz quit

    add edx, 1
    lea ecx, [ecx+ecx*4]            ; mul ecx * 5
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx]
    test eax, eax
    jnz lpst

  quit:
    lea eax, [ecx]

    ret 4
endif
atou endp
atou_endp:     ; out label

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

ShowCpu proc
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
OPT_Res	0
